blob: 6c51699a826a383b6c582a440fb197b9c63ec7a1 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36export JAVA="java"
37export JAVAC="javac -target 1.5"
38export RUN="${progdir}/etc/push-and-run-test-jar"
39
40info="info.txt"
41build="build"
42run="run"
43expected="expected.txt"
44output="output.txt"
45build_output="build-output.txt"
46run_args="--quiet"
47
48dev_mode="no"
49update_mode="no"
50debug_mode="no"
51usage="no"
52
53while true; do
54 if [ "x$1" = "x--host" ]; then
55 RUN="${progdir}/etc/host-run-test-jar"
56 shift
57 elif [ "x$1" = "x--reference" ]; then
58 RUN="${progdir}/etc/reference-run-test-classes"
59 shift
60 elif [ "x$1" = "x--jit" ]; then
61 run_args="${run_args} --jit"
62 shift
63 elif [ "x$1" = "x--fast" ]; then
64 run_args="${run_args} --fast"
65 shift
66 elif [ "x$1" = "x--portable" ]; then
67 run_args="${run_args} --portable"
68 shift
69 elif [ "x$1" = "x--debug" ]; then
70 run_args="${run_args} --debug"
71 shift
72 elif [ "x$1" = "x--gdb" ]; then
73 run_args="${run_args} --gdb"
74 dev_mode="yes"
75 shift
76 elif [ "x$1" = "x--zygote" ]; then
77 run_args="${run_args} --zygote"
78 shift
79 elif [ "x$1" = "x--no-verify" ]; then
80 run_args="${run_args} --no-verify"
81 shift
82 elif [ "x$1" = "x--no-optimize" ]; then
83 run_args="${run_args} --no-optimize"
84 shift
85 elif [ "x$1" = "x--no-precise" ]; then
86 run_args="${run_args} --no-precise"
87 shift
88 elif [ "x$1" = "x--valgrind" ]; then
89 run_args="${run_args} --valgrind"
90 shift
91 elif [ "x$1" = "x--dev" ]; then
92 run_args="${run_args} --dev"
93 dev_mode="yes"
94 shift
95 elif [ "x$1" = "x--update" ]; then
96 update_mode="yes"
97 shift
98 elif [ "x$1" = "x--help" ]; then
99 usage="yes"
100 shift
101 elif expr "x$1" : "x--" >/dev/null 2>&1; then
102 echo "unknown option: $1" 1>&2
103 usage="yes"
104 break
105 else
106 break
107 fi
108done
109
110if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
111 echo "--dev and --update are mutually exclusive" 1>&2
112 usage="yes"
113fi
114
115if [ "$usage" = "no" ]; then
116 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
117 test_dir=`basename "$oldwd"`
118 else
119 test_dir="$1"
120 fi
121
122 if [ '!' -d "$test_dir" ]; then
123 td2=`echo ${test_dir}-*`
124 if [ '!' -d "$td2" ]; then
125 echo "${test_dir}: no such test directory" 1>&2
126 usage="yes"
127 fi
128 test_dir="$td2"
129 fi
130
131 # Shift to get rid of the test name argument. The rest of the arguments
132 # will get passed to the test run.
133 shift
134fi
135
136if [ "$usage" = "yes" ]; then
137 prog=`basename $prog`
138 (
139 echo "usage:"
140 echo " $prog --help Print this message."
141 echo " $prog [options] [test-name] Run test normally."
142 echo " $prog --dev [options] [test-name] Development mode" \
143 "(dumps to stdout)."
144 echo " $prog --update [options] [test-name] Update mode" \
145 "(replaces expected.txt)."
146 echo ' Omitting the test name or specifying "-" will use the' \
147 "current directory."
148 echo " Runtime Options:"
149 echo " --fast Use the fast interpreter (the default)."
150 echo " --jit Use the jit."
151 echo " --portable Use the portable interpreter."
152 echo " --debug Wait for a debugger to attach."
153 #echo " --gdb Run under gdb; incompatible with some tests."
154 echo " --no-verify Turn off verification (on by default)."
155 echo " --no-optimize Turn off optimization (on by default)."
156 echo " --no-precise Turn off precise GC (on by default)."
157 echo " --zygote Spawn the process from the Zygote." \
158 "If used, then the"
159 echo " other runtime options are ignored."
160 echo " --host Use the host-mode virtual machine."
161 echo " --valgrind Use valgrind when running locally."
162 echo " --reference Use a host-local reference virtual machine."
163 ) 1>&2
164 exit 1
165fi
166
167cd "$test_dir"
168test_dir=`pwd`
169
170td_info="${test_dir}/${info}"
171td_expected="${test_dir}/${expected}"
172
173tmp_dir="/tmp/test-$$"
174
175if [ '!' '(' -r "$td_info" -a -r "$td_expected" ')' ]; then
176 echo "${test_dir}: missing files" 1>&2
177 exit 1
178fi
179
180# copy the test to a temp dir and run it
181
Elliott Hughes510c8782011-10-06 10:57:34 -0700182echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700183
184rm -rf "$tmp_dir"
185cp -Rp "$test_dir" "$tmp_dir"
186cd "$tmp_dir"
187
188if [ '!' -r "$build" ]; then
189 cp "${progdir}/etc/default-build" build
190fi
191
Elliott Hughes510c8782011-10-06 10:57:34 -0700192echo "${test_dir}: running..." 1>&2
193
jeffhao5d1ac922011-09-29 17:41:15 -0700194if [ '!' -r "$run" ]; then
195 cp "${progdir}/etc/default-run" run
196fi
197
198chmod 755 "$build"
199chmod 755 "$run"
200
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700201export TEST_NAME=`basename ${test_dir}`
202
jeffhao5d1ac922011-09-29 17:41:15 -0700203good="no"
204if [ "$dev_mode" = "yes" ]; then
205 "./${build}" 2>&1
206 echo "build exit status: $?" 1>&2
207 "./${run}" $run_args "$@" 2>&1
208 echo "run exit status: $?" 1>&2
209 good="yes"
210elif [ "$update_mode" = "yes" ]; then
211 "./${build}" >"$build_output" 2>&1
212 build_exit="$?"
213 if [ "$build_exit" = '0' ]; then
214 "./${run}" $run_args "$@" >"$output" 2>&1
215 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
216 good="yes"
217 else
218 cat "$build_output" 1>&2
219 echo "build exit status: $build_exit" 1>&2
220 fi
221else
222 "./${build}" >"$build_output" 2>&1
223 build_exit="$?"
224 if [ "$build_exit" = '0' ]; then
225 "./${run}" $run_args "$@" >"$output" 2>&1
226 else
227 cp "$build_output" "$output"
228 echo "build exit status: $build_exit" >>"$output"
229 fi
230 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
231 if [ "$?" = "0" ]; then
232 # output == expected
233 good="yes"
234 echo "${test_dir}: succeeded!" 1>&2
235 fi
236fi
237
238if [ "$good" = "yes" ]; then
239 cd "$oldwd"
240 rm -rf "$tmp_dir"
241 exit 0
242fi
243
244(
245 if [ "$update_mode" '!=' "yes" ]; then
246 echo "${test_dir}: FAILED!"
247 echo ' '
248 echo '#################### info'
249 cat "${td_info}" | sed 's/^/# /g'
250 echo '#################### diffs'
251 diff --strip-trailing-cr -u "$expected" "$output"
252 echo '####################'
253 echo ' '
254 fi
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700255 echo "${TEST_NAME} files left in ${tmp_dir}"
jeffhao5d1ac922011-09-29 17:41:15 -0700256) 1>&2
257
258exit 1